Canonical Format for RFCs
Paul Hoffman
ICANN
paul.hoffman@icann.org
09 August 2022
Internet-Draft
This document updates RFC 7990 by changing the definition of the "canonical format" for RFCs.
Introduction
[RFC7990] defines a framework for how RFCs would be published in the future, including new formats and a new canonical format for archiving RFCs.
This document updates [RFC7990] in that it changes the definition of the canonical format for RFCs. This document explicitly does not update the other documents referenced in [RFC7990].
Updated Definition of "Canonical Format"
Section 3 of [RFC7990] defines the canonical format as:
- Canonical format: the authorized, recognized, accepted, and archived version of the document
That definition is the only place in [RFC7990] that uses the word "archived" or "archive". [RFC6949] uses the word in a fashion similar to [RFC7990]. [RFC6635], the earlier model for the RFC Editor as a whole, says "The archive of RFC documents, any source documents needed to recreate the RFC documents, and any associated original documents (such as lists of errata, tools, and, for some early items, originals that are not machine readable) need to be secured against any kind of data storage failure."
These definitions never explicitly state that the initial archived version of a document must never change. However, some people in the IETF community have said that they make that assumption. Others say that the archived version can change to fix XML format errors as long as the underlying meaning of the text does not change.
At the time that this document is written, the RFC Editor has not changed the XML files for RFCs after they were published.
The definition of "canonical format" in Section 3 of [RFC7990] is updated to be:
- Canonical format: the authorized, recognized, accepted, and most recent archived version of the document
Section 5 of [RFC7990] says:
- The final XML file produced by the RFC Editor will be considered the canonical format for RFCs; it is the lowest common denominator that holds all the information intended for an RFC.
This wording does not take into account the need to change the XML file to fix XML errors. XML format errors, and better design choices, have been discovered by the community since the first RFCs were published using the XML format. In order to allow the RFC Editor to publish correct XML for all RFCs, Section 5 of [RFC7990] is updated to say:
- The XML file produced by the RFC Editor will be considered the canonical format for RFCs; it is the lowest common denominator that holds all the information intended for an RFC. The RFC Editor may change the file over time to incorporate changes in the XML format. The RFC Editor must also make available all earlier versions of the XML file.
[[ There is no need to bikeshed how the RFC Editor will make these available. They will propose a method, and the community will tell them if that's OK. ]]
IANA Considerations
This document has no IANA considerations.
Security Considerations
This document has the same security considerations as [RFC7990]. Those are:
Changing the format for RFCs involves modifying a great number of components to publication. Understanding those changes and the implications for the entire tool chain is critical so as to avoid unintended bugs that would allow unintended changes to text. Unintended changes to text could in turn corrupt a standard, practice, or critical piece of information about a protocol.

Normative References
[RFC7990]

RFC Format Framework
H. Flanagan
December 2016
RFC 7990
DOI 10.17487/RFC7990

Informative References
[RFC6635]

RFC Editor Model (Version 2)
O. Kolkman, Ed.
J. Halpern, Ed.
IAB
June 2012
RFC 6635
DOI 10.17487/RFC6635
[RFC6949]

RFC Series Format Requirements and Future Development
H. Flanagan
N. Brownlee
May 2013
RFC 6949
DOI 10.17487/RFC6949